/*
****************************************
**  Copyright  (C)  W.ch  1999-2015   **
**  Web:              http://wch.cn   **
****************************************
*/
/* USB host example for CH559, RootHUB²ͼ */
#include "CH57x_common.h"
#include "HID.h"
#include "HostUSB_MK.h"

// ȡHUB
const UINT8 SetupGetHubDescr[] = { HUB_GET_HUB_DESCRIPTOR, HUB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_HUB, 0x00, 0x00, sizeof(USB_HUB_DESCR), 0x00 };
// ȡHID豸
const UINT8 SetupGetHIDDevReportSetupGetHIDDevReport[] = { 0x81, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_REPORT, 0x00, 0x00, 0x49, 0x00 };
// SET_Report
const char SetupSetKeyReport[] = { 0x21, 0x09, 0x00, 0x02, 0x00, 0x00, 0x01, 0x00 };

MOUSE Mouse;
UINT8 Set_Port = 0;
/*
struct _RootHubDev{
  UINT8 DeviceStatus;     // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
  UINT8 DeviceAddress;    // 豸USBַ
  UINT8 DeviceSpeed;      // 0Ϊ,0Ϊȫ
  UINT8 DeviceType;       // 豸
  UINT8 GpVar;            // ͨñ
  UINT8 GpVar1;           // ͨñ1
} RootHubDev[2];
*/
#define HUB_MAX_PORTS 4

/*
Լ: USB豸ַ(οUSB_DEVICE_ADDR)
ֵַ  豸λ
0x02    Root-HUB0µUSB豸ⲿHUB
0x03    Root-HUB1µUSB豸ⲿHUB
0x1x    Root-HUB0µⲿHUBĶ˿xµUSB豸,xΪ1~n
0x2x    Root-HUB1µⲿHUBĶ˿xµUSB豸,xΪ1~n
*/
struct _DevOnHubPort {
  UINT8 DeviceStatus;     // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
  UINT8 DeviceAddress;    // 豸USBַ
  UINT8 DeviceSpeed;      // 0Ϊ,0Ϊȫ
  UINT8 DeviceType;       // 豸
  UINT8 GpVar;            // ͨñ
} DevOnHubPort[2][HUB_MAX_PORTS];         //Ĭ0
// ٶ:2ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)

BOOL    RootHubId;                                 // ǰڲroot-hub˿ں:0=HUB0,1=HUB1


UINT8 UsrCtrlGetHIDDeviceReport(UINT8 infc)    // ȡHID豸,TxBuffer
{
  UINT8 s;
  UINT8 len;
  UINT8 tmp[] = {0x21, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
  UINT8 tmp1[] = {0x81, 0x06, 0x00, 0x22, 0x00, 0x00, 0xff, 0x00};
  tmp[4] = infc;
  for (s = 0; s != sizeof(tmp); s ++) {
    ((PUINT8)pSetupReq)[ s ] = tmp[s];
  }
  s = HostCtrlTransfer(TxBuffer, &len);    // ִпƴ
  tmp1[4] = infc;
  for (s = 0; s != sizeof(tmp1); s ++) {
    ((PUINT8)pSetupReq)[ s ] = tmp1[s];
  }
  s = HostCtrlTransfer(TxBuffer, &len);    // ִпƴ
  if (s != ERR_SUCCESS) { return (s); }
  return (ERR_SUCCESS);
}

void  UsrSelectHubPort(UINT8 RootHubIndex, UINT8 HubPortIndex)    // HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
{
  if (HubPortIndex) {    // ѡָROOT-HUB˿ڵⲿHUBָ˿
    SetHostUsbAddr(DevOnHubPort[RootHubIndex][HubPortIndex - 1].DeviceAddress);  // USBǰUSB豸ַ
    if (DevOnHubPort[RootHubIndex][HubPortIndex - 1].DeviceSpeed == 0) {  // ͨⲿHUBUSB豸ͨѶҪǰID
      R8_UH_SETUP |= RB_UH_PRE_PID_EN;  // PRE PID
    }
    SetUsbSpeed(DevOnHubPort[RootHubIndex][HubPortIndex - 1].DeviceSpeed);  // õǰUSBٶ
  } else { // ѡָROOT-HUB˿
    PRINT("83\r\n");
    SetHostUsbAddr(ThisUsbDev.DeviceAddress);    // USBǰUSB豸ַ
    SetUsbSpeed(ThisUsbDev.DeviceSpeed);    // õǰUSBٶ
  }
  RootHubId = RootHubIndex ? 1 : 0;
}

UINT8 CtrlSetUsbRepot(UINT8 cfg)    // USB豸
{
  CopySetupReqPkg(SetupSetKeyReport);
  return (HostCtrlTransfer(&cfg, NULL));     // ִпƴ
}

UINT8 AnalyzeHidIntEndp(UINT8* buf)    // зHIDж϶˵ĵַ
{
  UINT8 i, s, l;
  s = 0;
  for (i = 0; i < ((PUSB_CFG_DESCR)buf) -> wTotalLength & 0xff; i += l) {      // ж϶˵,ͽӿ
    if (((PUSB_ENDP_DESCR)(buf + i)) -> bDescriptorType == USB_DESCR_TYP_ENDP   // Ƕ˵
        && (((PUSB_ENDP_DESCR)(buf + i)) -> bmAttributes & USB_ENDP_TYPE_MASK) == USB_ENDP_TYPE_INTER    // ж϶˵
        && (((PUSB_ENDP_DESCR)(buf + i)) -> bEndpointAddress & USB_ENDP_DIR_MASK)) {     // IN˵
      s = ((PUSB_ENDP_DESCR)(buf + i)) -> bEndpointAddress & USB_ENDP_ADDR_MASK;  // ж϶˵ĵַ
      break;  // ԸҪwMaxPacketSizebInterval
    }
    l = ((PUSB_ENDP_DESCR)(buf + i)) -> bLength;  // ǰ,
    if (l > 16) { break; }
  }
  return (s);
}

UINT8 AnalyzeMouseReportDesc(PUINT8 buf, UINT16 len)   // 걨
{
  UINT16 i = 0;
  UINT8 flagX, num;
  flagX = 0;
  while (i < len) {
    if ((buf[i]&Global_USAGE_PAGE) && (buf[i + 1] == UsagePage_BUTTON)) {
      PRINT("button     \n");
      i = i + 2;
      while (1) {
        if (((buf[i]&Local_USAGE_MINIMUM) == Local_USAGE_MINIMUM) && (buf[i] <= 0x1B)) {
          printf("button min %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          i = i + 1;
          Mouse.Button.Usage_min = buf[i];
        } else if (((buf[i]&Local_USAGE_MAXMUM) == Local_USAGE_MAXMUM) && (buf[i] <= 0x2B)) {
          printf("button max %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          i = i + 1;
          Mouse.Button.Usage_min = buf[i];
        } else if (((buf[i]&Global_LOGICAL_MINIMUM) == Global_LOGICAL_MINIMUM) && (buf[i] <= 0x17)) {
          printf("button lmin %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          i = i + 1;
          Mouse.Button.Logical_min = buf[i];
        } else if (((buf[i]&Global_LOGICAL_MAXIMUM) == Global_LOGICAL_MAXIMUM) && (buf[i] <= 0x27)) {
          printf("button lmax %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          i = i + 1;
          Mouse.Button.Logical_max = buf[i];
        } else if ((((buf[i]&Global_REPORT_SIZE) == Global_REPORT_SIZE) && (buf[i] <= 0x77) || (((buf[i]&Global_REPORT_COUNT) == Global_REPORT_COUNT)) && (buf[i] <= 0x97))) {
          printf("button cou %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          i = i + 1;
          Mouse.Button.Size_bit = buf[i] * buf[i + 2];
          printf("%02x  %02x ", (UINT16)buf[i], (UINT16)buf[i + 2]);
          printf("Mouse.Button.Size_bit  %02x  \n", (UINT16)Mouse.Button.Size_bit);
          if (Mouse.Button.Size_bit % 8) { //бλ
            while (1) {
              i = i + 1;
              if ((((buf[i]&Global_REPORT_SIZE) == Global_REPORT_SIZE) && (buf[i] <= 0x77) || (((buf[i]&Global_REPORT_COUNT) == Global_REPORT_COUNT)) && (buf[i] <= 0x97))) {
                num = buf[i] & 0x03;
                if (num > 1) { return Len_Err; } //һ1ֽ
                i = i + 1;
                Mouse.Button.Size_reserved = buf[i] * buf[i + 3];
                break;
              }
            }
          }
          break;
        }
        i++;
      }
    }
    if ((buf[i] == 9) && (buf[i + 1] == Usage_X)) {
      PRINT("xxx  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
      i = i + 2;
      if ((buf[i] == 9) && (buf[i + 1] == Usage_Y)) {
        printf("yyy  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
        i = i + 2;
      }
      if ((buf[i] == 9) && (buf[i + 1] == Usage_WHEEL)) {
        printf("wheel  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
        i = i + 2;
        flagX = 0x55;
      }
      while (1) {
        if (((buf[i]&Global_LOGICAL_MINIMUM) == Global_LOGICAL_MINIMUM) && (buf[i] <= 0x17)) {
          printf("xx lmin  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num >= 2) {Mouse.X_Y.Logical_min = buf[i + 1]; Mouse.X_Y.Logical_min <<= 8; Mouse.X_Y.Logical_min |= buf[i]; i = i + 2;}
          else {Mouse.X_Y.Logical_min = 0; Mouse.X_Y.Logical_min = buf[i]; i = i + 1;}
        } else if (((buf[i]&Global_LOGICAL_MAXIMUM) == Global_LOGICAL_MAXIMUM) && (buf[i] <= 0x27)) {
          printf("xx lmax  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num >= 2) {Mouse.X_Y.Logical_max = buf[i + 1]; Mouse.X_Y.Logical_max <<= 8; Mouse.X_Y.Logical_max |= buf[i]; i = i + 2;}
          else {Mouse.X_Y.Logical_max = 0; Mouse.X_Y.Logical_max = buf[i]; i = i + 1;}
        } else if ((((buf[i]&Global_REPORT_SIZE) == Global_REPORT_SIZE) && (buf[i] <= 0x77) || (((buf[i]&Global_REPORT_COUNT) == Global_REPORT_COUNT)) && (buf[i] <= 0x97))) {
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          printf("xx cou  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          i = i + 1;
          Mouse.X_Y.Size_bit = buf[i] * buf[i + 2];
          printf("%02x  %02x ", (UINT16)buf[i], (UINT16)buf[i + 2]);
          printf("Mouse.X_Y.Size_bit  %02x  \n", (UINT16)Mouse.X_Y.Size_bit);
          if (Mouse.X_Y.Size_bit % 8) { //бλ
            while (1) {
              i = i + 1;
              if ((((buf[i]&Global_REPORT_SIZE) == Global_REPORT_SIZE) && (buf[i] <= 0x77) || (((buf[i]&Global_REPORT_COUNT) == Global_REPORT_COUNT)) && (buf[i] <= 0x97))) {
                num = buf[i] & 0x03;
                if (num > 1) { return Len_Err; } //һ1ֽ
                i = i + 1;
                Mouse.X_Y.Size_reserved = buf[i] * buf[i + 3];
                break;
              }
            }
          }
          if (flagX == 0x55) {
            Mouse.Wheel_.Logical_min = Mouse.X_Y.Logical_min;
            Mouse.Wheel_.Logical_max = Mouse.X_Y.Logical_max;
            Mouse.Wheel_.Size_bit = Mouse.X_Y.Size_bit;
            Mouse.Wheel_.Size_reserved = Mouse.X_Y.Size_reserved;
          }
          break;
        }
        i++;
      }
    }
    if ((buf[i] == 9) && (buf[i + 1] == Usage_WHEEL) && (flagX == 0)) {
      PRINT("wheel  %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
      i = i + 2;
      while (1) {
        if (((buf[i]&Global_LOGICAL_MINIMUM) == Global_LOGICAL_MINIMUM) && (buf[i] <= 0x17)) {
          printf("wheel lmin %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num >= 2) {Mouse.Wheel_.Logical_min = buf[i + 1]; Mouse.Wheel_.Logical_min <<= 8; Mouse.Wheel_.Logical_min |= buf[i]; i = i + 2;}
          else {Mouse.Wheel_.Logical_min = 0; Mouse.Wheel_.Logical_min = buf[i]; i = i + 1;}
        } else if (((buf[i]&Global_LOGICAL_MAXIMUM) == Global_LOGICAL_MAXIMUM) && (buf[i] <= 0x27)) {
          printf("wheel  lmax %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          num = buf[i] & 0x03;
          if (num >= 2) {Mouse.Wheel_.Logical_max = buf[i + 1]; Mouse.Wheel_.Logical_max <<= 8; Mouse.Wheel_.Logical_max |= buf[i]; i = i + 2;}
          else {Mouse.Wheel_.Logical_max = 0; Mouse.Wheel_.Logical_max = buf[i]; i = i + 1;}
        } else if ((((buf[i]&Global_REPORT_SIZE) == Global_REPORT_SIZE) && (buf[i] <= 0x77) || (((buf[i]&Global_REPORT_COUNT) == Global_REPORT_COUNT)) && (buf[i] <= 0x97))) {
          num = buf[i] & 0x03;
          if (num > 1) { return Len_Err; } //һ1ֽ
          printf("wheel  cou %02x  %02x  \n", (UINT16)i, (UINT16)buf[i]);
          i = i + 1;
          Mouse.Wheel_.Size_bit = buf[i] * buf[i + 2];
          PRINT("%02x  %02x ", (UINT16)buf[i], (UINT16)buf[i + 2]);
          PRINT("Mouse.Wheel_.Size_bit  %02x  \n", (UINT16)Mouse.Wheel_.Size_bit);
          if (Mouse.Wheel_.Size_bit % 8) { //бλ
            while (1) {
              i = i + 1;
              if ((((buf[i]&Global_REPORT_SIZE) == Global_REPORT_SIZE) && (buf[i] <= 0x77) || (((buf[i]&Global_REPORT_COUNT) == Global_REPORT_COUNT)) && (buf[i] <= 0x97))) {
                num = buf[i] & 0x03;
                if (num > 1) { return Len_Err; } //һ1ֽ
                i = i + 1;
                Mouse.Wheel_.Size_reserved = buf[i] * buf[i + 3];
                break;
              }
            }
          }
          break;
        }
        i++;
      }
    }
    i = i + 1;
    if (i >= len) { return Success; }
  }
  return Unknow;
}


UINT8 UsrInitRootDevice(UINT8 RootHubIndex)    // ʼָROOT-HUB˿ڵUSB豸
// : HUB˿ں0/1
{
  UINT8 i, s, cfg, dv_cls, if_cls;
  UINT8 infcNum = 1;
  UINT8 cfg1 = 0;
  UINT16 hidReportLen;
  //RootHubIndex = 0;
  PRINT("Reset root hub %1d# port\n", (UINT16)RootHubIndex);
  mDelaymS(10);
  ResetRootHubPort();    // ⵽豸,λӦ˿ڵUSB
  for (i = 0, s = 0; i < 100; i ++) {    // ȴUSB豸λ,100mSʱ
    if (EnableRootHubPort() == ERR_SUCCESS) {     // ʹROOT-HUB˿
      i = 0;
      s ++;  // ʱȴUSB豸Ӻȶ
      if (s > 15) { break; }    // Ѿȶ15ms
    }
    mDelaymS(1);
  }

  UsrSelectHubPort(RootHubIndex, 0);
  if (i) {    // λ豸û
    DisableRootHubPort();
    PRINT("Disable root hub %1d# port because of disconnect\n", (UINT16)RootHubIndex);
    return (ERR_USB_DISCON);
  }
  PRINT("GetDevDescr: ");
  s = CtrlGetDeviceDescr();   // ȡ豸
  if (s == ERR_SUCCESS) {
    //for (i = 0; i < ((PUSB_SETUP_REQ)SetupGetDevDescr) -> wLength & 0xff; i ++) { printf("x%02X ", (UINT16)(TxBuffer[i])); }
    for (i = 0; i < ((PUSB_SETUP_REQ)SetupGetDevDescr)->wLength; i ++) {
      PRINT("x%02X ", (UINT16)(Com_Buffer[i]));
    }
    PRINT("##\r\n");   // ʾ
    ThisUsbDev.DeviceVID = ((PUSB_DEV_DESCR)Com_Buffer)->idVendor; //VID PIDϢ
    ThisUsbDev.DevicePID = ((PUSB_DEV_DESCR)Com_Buffer)->idProduct;
    dv_cls = ((PUSB_DEV_DESCR)Com_Buffer) -> bDeviceClass;
    s = CtrlSetUsbAddress(((PUSB_SETUP_REQ)SetupSetUsbAddr)->wValue);
    if (s == ERR_SUCCESS) {
      ThisUsbDev.DeviceAddress = ((PUSB_SETUP_REQ)SetupSetUsbAddr)->wValue;
      PRINT("GetCfgDescr: ");
      s = CtrlGetConfigDescr();   // ȡ
      if (s == ERR_SUCCESS) {
        infcNum = ((PUSB_CFG_DESCR)Com_Buffer)->bNumInterfaces;  //ӿĿ
        cfg = ((PUSB_CFG_DESCR)Com_Buffer) -> bConfigurationValue;
        for (i = 0; i < ((PUSB_CFG_DESCR)Com_Buffer) -> wTotalLength & 0xff; i ++) { printf("x%02X ", (UINT16)(TxBuffer[i])); }
        PRINT("\n");
        /* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
        if_cls = ((PXUSB_CFG_DESCR_LONG)Com_Buffer) -> itf_descr.bInterfaceClass;    // ӿ
        if (dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ((PXUSB_CFG_DESCR_LONG)TxBuffer) -> itf_descr.bInterfaceSubClass <= 0x01) {      // HID豸,/
          s = AnalyzeHidIntEndp(Com_Buffer);    // зHIDж϶˵ĵַ
          ThisUsbDev.GpVar[0] = s & USB_ENDP_ADDR_MASK;
          if_cls = ((PUSB_CFG_DESCR_LONG)Com_Buffer) -> itf_descr.bInterfaceProtocol;
          hidReportLen = Com_Buffer[26];
          hidReportLen <<= 8;
          hidReportLen |= Com_Buffer[25];  //ֻһȣ豸
          PRINT("hidReportLen:%02X \n", (UINT16)(hidReportLen));
          s = CtrlSetUsbConfig(cfg);    // USB豸
          if (s == ERR_SUCCESS) {
            PRINT("GetHIDReport: ");
            s = UsrCtrlGetHIDDeviceReport(0);//ȡ
            if (s == ERR_SUCCESS) {
              for (i = 0; i < hidReportLen; i++) {
                PRINT("x%02X ", (UINT16)(TxBuffer[i]));
              }
              PRINT("\n");
            }
            if (if_cls == 2) { //걨
              PRINT("begin\r\n");
              AnalyzeMouseReportDesc(Com_Buffer, hidReportLen);
              PRINT("%02x  %02x  %02x  \r\n", (UINT16)(Mouse.Button.Size_bit), (UINT16)(Mouse.X_Y.Size_bit), (UINT16)(Mouse.Wheel_.Size_bit));
            }
            infcNum--;
            while (infcNum >= 1) {
              PRINT("GetHIDReport: %02x ", (UINT16)infcNum);
              s = UsrCtrlGetHIDDeviceReport(infcNum);//ȡ
              if (s == ERR_SUCCESS) {
                #ifdef UART0_DEBUG
                i = 0;
                while (Com_Buffer[i] != 0xc0) {
                  PRINT("x%02X ", (UINT16)(Com_Buffer[i]));
                  i++;
                }
                PRINT("\r\n");
                #endif
              }
              infcNum--;
            }
            //      Set_Idle( );     豣˵ϢԱUSB
            ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
            if (if_cls == 1) {
              ThisUsbDev.DeviceType = DEV_TYPE_KEYBOARD;
              //              һʼ,豸ָʾLED
              CtrlSetUsbRepot(1);
              PRINT("USB-Keyboard Ready\n");
              SetUsbSpeed(1);    // ĬΪȫ
              return (ERR_SUCCESS);
            } else if (if_cls == 2) {
              ThisUsbDev.DeviceType = DEV_TYPE_MOUSE;
              //              ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
              PRINT("USB-Mouse Ready\n");
              SetUsbSpeed(1);    // ĬΪȫ
              return (ERR_SUCCESS);
            }
            s = ERR_USB_UNSUPPORT;
          }
        } else { // Խһ
          s = CtrlSetUsbConfig(cfg);    // USB豸
          if (s == ERR_SUCCESS) {  //            豣˵ϢԱUSB
            ThisUsbDev.DeviceStatus = ROOT_DEV_SUCCESS;
            ThisUsbDev.DeviceStatus = dv_cls ? dv_cls : if_cls;
            SetUsbSpeed(1);    // ĬΪȫ
            PRINT("Nonsupport Dev\n");
            return (ERR_SUCCESS);   /* δ֪豸ʼɹ */
          }
        }
      }
    }
  }
  PRINT("InitRootDev Err = %02X\n", (UINT16)s);
  ThisUsbDev.DeviceStatus = ROOT_DEV_FAILED;
  SetUsbSpeed(1);    // ĬΪȫ
  return (s);
}


UINT16  SearchTypeDevice(UINT8 type)    // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
{
  // 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
  // ȻҲԸUSBĳVIDƷPID(Ҫ¼豸VIDPID),Լָ
  UINT8 RootHubIndex, HubPortIndex;
  //for ( RootHubIndex = 0; RootHubIndex != 2; RootHubIndex ++ )
  {
    // ʱԱ豸;γĳЩϢδʱµ
    if (ThisUsbDev.DeviceType == type && ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS) { GetKey((UINT16)RootHubIndex << 8); }     // ƥöٳɹ,ROOT-HUB˿
    if (ThisUsbDev.DeviceType == USB_DEV_CLASS_HUB && ThisUsbDev.DeviceStatus >= ROOT_DEV_SUCCESS) {    // ⲿHUBöٳɹ
      for (HubPortIndex = 1; HubPortIndex <= ThisUsbDev.GpVar[0]; HubPortIndex ++) {    // ⲿHUBĸ˿
        if (DevOnHubPort[RootHubIndex][HubPortIndex - 1].DeviceType == type && DevOnHubPort[RootHubIndex][HubPortIndex - 1].DeviceStatus >= ROOT_DEV_SUCCESS)
        { GetKey(((UINT16)RootHubIndex << 8) | HubPortIndex); }      // ƥöٳɹ
      }
    }
  }
  return (0xFFFF);
}

UINT8 SETorOFFNumLock(PUINT8 buf)//NumLockĵж
{
  UINT8 tmp[] = {0x21, 0x09, 0x00, 0x02, 0x00, 0x00, 0x01, 0x00};
  UINT8 len, s;
  if ((buf[2] == 0x53) & (buf[0] | buf[1] | buf[3] | buf[4] | buf[5] | buf[6] | buf[7] == 0)) {
    for (s = 0; s != sizeof(tmp); s ++) {
      ((UINT8*)pSetupReq)[ s ] = tmp[s];
    }
    s = HostCtrlTransfer(TxBuffer, &len);    // ִпƴ
    if (s != ERR_SUCCESS) { return (s); }
  }
  return (ERR_SUCCESS);
}

void GetKey(UINT16 Port_Ep)
{
  UINT8 i, s, len, endp;
  UINT16  loc = Port_Ep;//
  //printf("[Line=%d],%d\r\n", __LINE__, Port_Ep);
  if (Port_Ep != 0xFFFF) {    // ҵ,KeyBoardδ?
    //printf("[Line=%d],%d\r\n", __LINE__, Port_Ep);
    i = 1;//(UINT8)( loc >> 8 );
    len = 0;//(UINT8)loc;
    SetHostUsbAddr(ThisUsbDev.DeviceAddress);    // USBǰUSB豸ַ
    SetUsbSpeed(ThisUsbDev.DeviceSpeed);    // õǰUSBٶ
    //UsrSelectHubPort( i, len );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
    endp = ThisUsbDev.GpVar[0];  // ж϶˵ĵַ,λ7ͬ־λ
    if (endp & USB_ENDP_ADDR_MASK) {    // ˵Ч
      s = USBHostTransact(USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0);    // CH559,ȡ,NAK
      if (s == ERR_SUCCESS) {
        endp ^= 0x80;  // ͬ־ת
        ThisUsbDev.GpVar[0] = endp;
        len = R8_USB_RX_LEN;  // յݳ
        if (len) {
          PRINT ("%04X data: ", loc);
          for (i = 0; i < len; i ++) { PRINT ("x%02X ", (UINT16)(RxBuffer[i])); }
          PRINT ("\r\n");
        }
      } else if (s != (USB_PID_NAK | ERR_USB_TRANSFER)) { PRINT ("Dev error %02x\n", (UINT16)s); }   // ǶϿ
    } else { PRINT ("Dev no interrupt endpoint\n"); }
    SetUsbSpeed(1);    // ĬΪȫ
  }
}





